From: "Daniel P. Berrange" <berrange@redhat.com>
To: qemu-devel@nongnu.org
Cc: "Philippe Mathieu-Daudé" <f4bug@amsat.org>,
"Alexey Kardashevskiy" <aik@ozlabs.ru>,
"Peter Maydell" <peter.maydell@linaro.org>,
"Daniel P. Berrange" <berrange@redhat.com>
Subject: [Qemu-devel] [PATCH v2 4/4] build: don't fail if given a git submodule which does not exist
Date: Fri, 27 Oct 2017 14:14:12 +0100 [thread overview]
Message-ID: <20171027131412.18830-5-berrange@redhat.com> (raw)
In-Reply-To: <20171027131412.18830-1-berrange@redhat.com>
If going back in time in git history, across a commit that introduces a new
submodule, the 'git-submodule.sh' script will fail, causing rebuild to fail.
This is because config-host.mak contains a GIT_SUBMODULES variable that lists
a submodule that only exists in the later commit. config-host.mak won't get
repopulated until config.status is invoked, but make won't get this far due to
the submodule error.
This change makes 'git-submodule.sh' check whether each module is known to git
and drops any which are not present. A warning message will be printed when any
submodule is dropped in this manner.
Signed-off-by: Daniel P. Berrange <berrange@redhat.com>
---
scripts/git-submodule.sh | 16 ++++++++++++++--
1 file changed, 14 insertions(+), 2 deletions(-)
diff --git a/scripts/git-submodule.sh b/scripts/git-submodule.sh
index 30fd83db55..60b3b9bdeb 100755
--- a/scripts/git-submodule.sh
+++ b/scripts/git-submodule.sh
@@ -7,7 +7,7 @@ substat=".git-submodule-status"
command=$1
shift
-modules="$@"
+maybe_modules="$@"
test -z "$GIT" && GIT=git
@@ -16,12 +16,24 @@ error() {
exit 1
}
-if test -z "$modules"
+if test -z "$maybe_modules"
then
test -e $substat || touch $substat
exit 0
fi
+modules=""
+for m in $maybe_modules
+do
+ $GIT submodule status $m 1> /dev/null 2>&1
+ if test $? == 0
+ then
+ modules="$modules $m"
+ else
+ echo "warn: ignoring non-existant submodule $m"
+ fi
+done
+
if ! test -e ".git"
then
echo "$0: unexpectedly called with submodules but no git checkout exists"
--
2.13.6
next prev parent reply other threads:[~2017-10-27 13:14 UTC|newest]
Thread overview: 20+ messages / expand[flat|nested] mbox.gz Atom feed top
2017-10-27 13:14 [Qemu-devel] [PATCH v2 0/4] Various improvements to submodule handling Daniel P. Berrange
2017-10-27 13:14 ` [Qemu-devel] [PATCH v2 1/4] build: allow setting a custom GIT binary for transparent proxying Daniel P. Berrange
2017-10-28 1:53 ` Alexey Kardashevskiy
2017-10-28 20:45 ` Daniel P. Berrange
2017-10-29 1:47 ` Alexey Kardashevskiy
2017-10-29 7:57 ` Daniel P. Berrange
2017-10-29 14:08 ` Alexey Kardashevskiy
2017-10-29 16:29 ` Daniel P. Berrange
2017-10-29 23:49 ` Alexey Kardashevskiy
2017-10-30 7:52 ` Daniel P. Berrange
2017-10-31 3:30 ` Alexey Kardashevskiy
2017-10-27 13:14 ` [Qemu-devel] [PATCH v2 2/4] build: don't create temporary files in source dir Daniel P. Berrange
2017-10-28 5:25 ` Eric Blake
2017-10-28 6:37 ` Alexey Kardashevskiy
2017-10-27 13:14 ` [Qemu-devel] [PATCH v2 3/4] build: allow automatic git submodule updates to be disabled Daniel P. Berrange
2017-10-28 5:28 ` Eric Blake
2017-10-27 13:14 ` Daniel P. Berrange [this message]
2017-10-28 1:27 ` [Qemu-devel] [PATCH v2 4/4] build: don't fail if given a git submodule which does not exist Alexey Kardashevskiy
2017-10-28 5:58 ` Eric Blake
2017-10-28 5:34 ` [Qemu-devel] [PATCH v2 0/4] Various improvements to submodule handling Eric Blake
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20171027131412.18830-5-berrange@redhat.com \
--to=berrange@redhat.com \
--cc=aik@ozlabs.ru \
--cc=f4bug@amsat.org \
--cc=peter.maydell@linaro.org \
--cc=qemu-devel@nongnu.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.